Skip to content
Snippets Groups Projects
mysql.in 9.57 KiB
Newer Older
  • Learn to ignore specific revisions
  • # -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
    
    # vim: set filetype=sh sw=3 sts=3 expandtab autoindent:
    
    elijah's avatar
    elijah committed
    #
    # mysql handler script for backupninja
    #
    
    getconf backupdir /var/backups/mysql
    getconf databases all
    
    elijah's avatar
    elijah committed
    getconf dbhost localhost
    
    elijah's avatar
    elijah committed
    getconf hotcopy no
    
    elijah's avatar
    elijah committed
    getconf sqldump no
    
    getconf sqldumpoptions "--lock-tables --complete-insert --add-drop-table --quick --quote-names"
    
    elijah's avatar
    elijah committed
    getconf compress yes
    
    micah's avatar
    micah committed
    getconf vsname
    
    elijah's avatar
    elijah committed
    
    
    elijah's avatar
    elijah committed
    # authentication:
    getconf user
    getconf dbusername
    getconf dbpassword
    getconf configfile /etc/mysql/debian.cnf
    
    
    # Decide if the handler should operate on a vserver or on the host.
    # In the former case, check that $vsname exists and is running.
    
    if [ $vservers_are_available = yes ]; then
    
          # does it exist ?
          if ! vservers_exist "$vsname" ; then
             fatal "The vserver given in vsname ($vsname) does not exist."
          fi
          # is it running ?
    
          vservers_running $vsname || fatal "The vserver $vsname is not running."
    
          # everything ok
          info "Using vserver '$vsname'."
          usevserver=yes
          vroot="$VROOTDIR/$vsname"
       else
          info "No vserver name specified, actions will be performed on the host."
       fi
    
    micah's avatar
    micah committed
    fi
    
    
    ## Prepare ignore part of the command
    ## This only works for mysqldump at the moment
    
    ignore=''
    
       ignore="$ignore --ignore-table=$i"
    
    # create backup dirs, $vroot will be empty if no vsname was specified
    # and we will instead proceed to operate on the host
    
    micah's avatar
    micah committed
    [ -d $vroot$backupdir ] || mkdir -p $vroot$backupdir
    [ -d $vroot$backupdir ] || fatal "Backup directory '$vroot$backupdir'"
    
    elijah's avatar
    elijah committed
    hotdir="$backupdir/hotcopy"
    dumpdir="$backupdir/sqldump"
    
    micah's avatar
    micah committed
    
    
    if [ $usevserver = yes ]
    
    micah's avatar
    micah committed
    then
    
       [ "$sqldump" == "no" -o -d $vroot$dumpdir ] || $VSERVER $vsname exec mkdir -p $dumpdir
       [ "$hotcopy" == "no" -o -d $vroot$hotdir ] || $VSERVER $vsname exec mkdir -p $hotdir
    
    micah's avatar
    micah committed
    else
    
       [ "$sqldump" == "no" -o -d $dumpdir ] || mkdir -p $dumpdir
       [ "$hotcopy" == "no" -o -d $hotdir ] || mkdir -p $hotdir
    
    micah's avatar
    micah committed
    fi
    
    elijah's avatar
    elijah committed
    
    
    elijah's avatar
    elijah committed
    #######################################################################
    ## AUTHENTICATION
    
    #
    # one of three authentication methods:
    # 1. setting the user, so that /home/user/.my.cnf is used.
    # 2. specifying the user and password in the handler config,
    #    which generates a temporary .my.cnf in /root/.my.cnf
    
    # 3. specify the config file with --defaults-extra-file
    
    elijah's avatar
    elijah committed
    #    (this option DOESN'T WORK WITH MYSQLHOTCOPY)
    #
    
    
    elijah's avatar
    elijah committed
    # create .my.cnf
    
    # only if dbusername and dbpassword specified.
    
    elijah's avatar
    elijah committed
    # we create a tmp file because we don't want to
    
    # specify the password on the command line.
    
    elijah's avatar
    elijah committed
    
    
    defaultsfile=""
    
    if [ -n "$dbusername" -a -n "$dbpassword" ]
    
       if [ $usevserver = yes ]
       then
          home=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
       else
          home=`getent passwd "root" | @AWK@ -F: '{print $6}'`
       fi
    
       [ -d $home ] || fatal "Can't find root's home directory ($home)."
    
       mycnf="$home/.my.cnf"
    
       if [ $usevserver = yes ]
       then
    
       if [ -f $workcnf ]
       then
    
          # rename temporarily
          tmpcnf="$workcnf.disable"
          debug "mv $workcnf $tmpcnf"
          mv $workcnf $tmpcnf
    
       oldmask=`umask`
       umask 077
       cat > $workcnf <<EOF
    
    elijah's avatar
    elijah committed
    # auto generated backupninja mysql conf
    [mysql]
    
    host=$dbhost
    
    elijah's avatar
    elijah committed
    user=$dbusername
    
    password="$dbpassword"
    
    elijah's avatar
    elijah committed
    
    [mysqldump]
    
    host=$dbhost
    
    elijah's avatar
    elijah committed
    user=$dbusername
    
    password="$dbpassword"
    
    elijah's avatar
    elijah committed
    
    [mysqlhotcopy]
    
    host=$dbhost
    
    elijah's avatar
    elijah committed
    user=$dbusername
    
    password="$dbpassword"
    
    
    [mysqladmin]
    host=$dbhost
    user=$dbusername
    password="$dbpassword"
    
    elijah's avatar
    elijah committed
    EOF
    
       umask $oldmask
       defaultsfile="--defaults-extra-file=$mycnf"
    
    # else, if a user is set use her .my.cnf
    elif [ -n "$user" ]
    then
    
       userset=true;
       if [ $usevserver = yes ]
       then
          userhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
          if [ $? -eq 2 ]
          then
    	 fatal "User $user not found in /etc/passwd"
          fi
          debug "User home set to: $vroot$userhome"
          [ -f $vroot$userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
       else
          userhome=`getent passwd "$user" | @AWK@ -F: '{print $6}'`
          if [ $? -eq 2 ]
          then
    	 fatal "User $user not found in /etc/passwd"
          fi
          debug "User home set to: $userhome"
          [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
       fi
    
       defaultsfile="--defaults-extra-file=$userhome/.my.cnf"
       debug "using $defaultsfile"
    
    # otherwise use $configfile
    else
       user=root
       defaultsfile="--defaults-extra-file=$configfile"
    
    elijah's avatar
    elijah committed
    #######################################################################
    
    elijah's avatar
    elijah committed
    ## HOT COPY
    
    
    if [ "$hotcopy" == "yes" ]
    then
    
       info "Initializing hotcopy method"
       if [ "$databases" == "all" ]
       then
          if [ $usevserver = yes ]
          then
             info "dbhost: $dbhost"
             execstr="$VSERVER $vsname exec $MYSQLHOTCOPY -h $dbhost --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
          else
             execstr="$MYSQLHOTCOPY --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
          fi
          debug "su $user -c \"$execstr\""
          if [ ! $test ]
          then
             output=`su $user -c "$execstr" 2>&1`
             code=$?
             if [ "$code" == "0" ]
             then
                debug $output
                info "Successfully finished hotcopy of all mysql databases"
             else
                warning $output
                warning "Failed to hotcopy all mysql databases"
             fi
          fi
       else
          for db in $databases
          do
             if [ $usevserver = yes ]
             then
                execstr="$VSERVER $vsname exec $MYSQLHOTCOPY --allowold $db $hotdir"
             else
                execstr="$MYSQLHOTCOPY --allowold $db $hotdir"
             fi
             debug 'su $user -c \"$execstr\"'
             if [ ! $test ]
             then
                output=`su $user -c "$execstr" 2>&1`
                code=$?
                if [ "$code" == "0" ]
                then
                   debug $output
                   info "Successfully finished hotcopy of mysql database $db"
                else
                   warning $output
                   warning "Failed to hotcopy mysql database $db"
                fi
             fi
          done
       fi
    
    elijah's avatar
    elijah committed
    fi
    
    elijah's avatar
    elijah committed
    
    ##########################################################################
    
    elijah's avatar
    elijah committed
    ## SQL DUMP
    
    
    if [ "$sqldump" == "yes" ]
    then
    
       info "Initializing SQL dump method"
       if [ "$databases" == "all" ]
       then
          if [ $usevserver = yes ]
          then
    
             debug 'set -o pipefail ; echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
             databases=`set -o pipefail ; echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
    
             if [ $? -ne 0 ]
             then
                fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
             fi
          else
    
             databases=$(set -o pipefail ; su $user -c "$MYSQL $defaultsfile -N -B -e 'show databases'" | sed 's/|//g;/\+----/d')
    
             if [ $? -ne 0 ]
             then
                fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
             fi
          fi
       fi
    
    elijah's avatar
    elijah committed
    
    
       for db in $databases
       do
          DUMP_BASE="$MYSQLDUMP $defaultsfile $sqldumpoptions"
    
    
          case "$db" in
             information_schema)
                DUMP_BASE="${DUMP_BASE} --skip-lock-tables"
                ;;
             performance_schema)
                DUMP_BASE="${DUMP_BASE} --skip-lock-tables --skip-events"
                ;;
          esac
    
          # Dumping structure and data
          DUMP="$DUMP_BASE $ignore $db"
    
          # If requested, dump only the table structure for this database
          if echo "$nodata" | grep -E '(^|[[:space:]])'"$db\." >/dev/null
          then
             # Get the structure of the tables, without data
             DUMP_STRUCT="$DUMP_BASE --no-data $db"
             for qualified_table in $nodata
             do
                table=$( expr match "$qualified_table" "$db\.\([^\w]*\)" )
                DUMP_STRUCT="$DUMP_STRUCT $table"
             done
             DUMP="( $DUMP; $DUMP_STRUCT )"
          fi
          if [ $usevserver = yes ]
          then
             # Test to make sure mysqld is running, if it is not sqldump will not work
             $VSERVER $vsname exec su $user -c "$MYSQLADMIN $defaultsfile ping 2>&1 >/dev/null"
             if [ $? -ne 0 ]; then
                fatal "mysqld doesn't appear to be running!"
             fi
             if [ "$compress" == "yes" ]; then
    
                execstr="$VSERVER $vsname exec $DUMP | $GZIP $GZIP_OPTS > '$vroot$dumpdir/${db}.sql.gz'"
    
                execstr="$VSERVER $vsname exec $DUMP -r '$vroot$dumpdir/${db}.sql'"
    
             fi
          else
             # Test to make sure mysqld is running, if it is not sqldump will not work
             su $user -c "$MYSQLADMIN $defaultsfile ping 2>&1 >/dev/null"
             if [ $? -ne 0 ]; then
                fatal "mysqld doesn't appear to be running!"
             fi
             if [ "$compress" == "yes" ]; then
    
                execstr="$DUMP | $GZIP $GZIP_OPTS > '$dumpdir/${db}.sql.gz'"
    
                execstr="$DUMP -r '$dumpdir/${db}.sql'"
    
             fi
          fi
          debug "su $user -c \"$execstr\""
          if [ ! $test ]
          then
    
             output=`su $user -s /bin/bash -c "set -o pipefail ; $execstr" 2>&1`
    
             code=$?
             if [ "$code" == "0" ]
             then
                debug $output
                info "Successfully finished dump of mysql database $db"
             else
                warning $output
                warning "Failed to dump mysql databases $db"
             fi
          fi
       done
    
    elijah's avatar
    elijah committed
    
    
    # clean up tmp config file
    
    if [ "$dbusername" != "" -a "$dbpassword" != "" ]
    
       ## clean up tmp config file
       debug "rm $workcnf"
       rm $workcnf
       if [ -f "$tmpcnf" ]
       then
          debug "mv $tmpcnf $workcnf"
          mv $tmpcnf $workcnf
       fi
    
    elijah's avatar
    elijah committed
    fi
    
    return 0